﻿var commitId = "commitObject";
var commit_swf_url = "../../modelers/commit.swf";
var expressInstall_swf_url = "../../modelers/expressInstall.swf";
var commitObj = null;
var commitFlag = false;
var commitURL = String(replaceSymbol(document.URL,"\\","/"));
//
var questionURL = null;
//
var _DoFSCommandPrev;
var objSD = {};
var objP = {};
var objQplayer;
var flagLoadTestProps = false;
//
var noQuestionResponse, oneAttempt, noHint, noPartial, autoNext, testFinished, progress, noAPIFound, testProps, completionStatus, score;
var aSessionAttribs = ["duration", "score", "status", "visits", "attempts", "totalDuration", "timeStart", "timeFirstStart", "testProps", "timeEnd"];
var aPropAttribs = ["scoreweight", "progressweight", "type", "caption", "estimated", "optional", "showinregister", "estimatecorrect", "showresponse", "num", "src"];
//
function onCommitState(){
	var sMsg = new String(onCommitState.arguments[0]).toLowerCase();
	switch(String(sMsg)){
	case ("ready"):
		commitObj = document.getElementById(commitId + "_swf");
		if(commitFlag){
			commitFlag = false;
			fOnLoad();
		}
		break;
	default:;
	}
}
//
function my_onkeydown_handler(){
	switch (event.keyCode){
	case 116 : // 'F5'
		event.returnValue = false;
		event.keyCode = 0;
		window.status = "We have disabled F5";
		break;
	}
} 
//
function setSessionDataAndProps(){
	if(setSessionDataAndProps.arguments.length < 1){
		return;
	}
	var obj = setSessionDataAndProps.arguments[0], l, i;
	l = aSessionAttribs.length;
	for(i=0; i<l; i++){
		objSD[aSessionAttribs[i]] = obj[aSessionAttribs[i]];
	}
	l = aPropAttribs.length;
	for(i=0;i<l;i++){
		objP[aPropAttribs[i]] = obj[aPropAttribs[i]];
	}
	//
	noQuestionResponse = obj.noQuestionResponse;
	oneAttempt = obj.oneAttempt;
	noHint = obj.noHint;
	noPartial = obj.noPartial;
	autoNext = obj.autoNext;
	progress = obj.progress;
	testFinished = obj.testFinished;
	noAPIFound = obj.noAPIFound;	
	//
	flagLoadTestProps = true;
}
//
function sendSessionDataAndProps(){
	var obj = {progress:progress, testFinished:testFinished}, i, l;
	l = aSessionAttribs.length;
	for(i=0; i<l; i++){
		obj[aSessionAttribs[i]] = objSD[aSessionAttribs[i]];
	}
	l = aPropAttribs.length;
	for(i=0; i<l; i++){
		obj[aPropAttribs[i]] = objP[aPropAttribs[i]];
	}
	//alert("FROM QUESTION URL: "+document.URL+" testProps: "+obj.testProps);
	commitObj.sendSessionDataAndProps(commitURL, true, obj);
}
//
function finishQplayer(){
	if(objQplayer != undefined){
		try {
			objQplayer.intervalCount = -1;
			setVar(objQplayer, '_root.finishPlayer', 'true');
		} catch (err) {
		}
	}
}
//
function setDataValueLC(sVar, v){
	if(commitObj == null){
		return;
	}
	commitObj.setDataValue(commitURL, true, sVar, v);
}
//
function nextQuestionLC(){
	if(commitObj == null){
		return;
	}
	commitObj.nextQuestion(commitURL, true, true);
}
//
function resumeTimerLC(){
	if(commitObj == null){
		return;
	}
	commitObj.resumeTimer(commitURL, true);
}
//
function _DoFSCommandLC(command, args, id){
	var sCommand = String(command).toLowerCase();
	switch(sCommand){
	case "qplayerready":
		_DoFSCommandPrev(command, args, id);
		objSD.timeStart = (new Date()).getTime();
		if(noQuestionResponse){
			setVar(objQplayer, '_root.noResponse', 'true');
		}
		if(oneAttempt){
			setVar(objQplayer, '_root.attemptLimit', '1');
		}
		if(noHint){
			setVar(objQplayer, '_root.noHintNoSolution', 'true');
		}
		if (flagLoadTestProps) {
			if ((objQplayer != undefined) && (objSD.testProps != undefined)) {
				objQplayer.intervalCount = -1;
				if (objQplayer.intervalCount == -1) {
					//если настройки безопасности не запрещают доступ к объекту
					setVar(objQplayer, '_root.testProps', objSD.testProps);
				}
			}
			flagLoadTestProps = false;
		}
		if((objSD.timeFirstStart == undefined) && !testFinished){
			objSD.timeFirstStart = new Date();
			objSD.timeFirstStart.setTime(objSD.timeStart);
			if(!isNaN(objP.progressweight) && !objP.optional) {
				progress += objP.progressweight;
				if (String(noAPIFound) == "false") {
					setDataValueLC("cmi.progress_measure", progress.toFixed(7));
				}
				
			}
			if (objSD.status == "unknown") {
				objSD.status = "not attempted";
			}
		}
		if(testFinished){
			setVar(objQplayer, '_root.finishPlayer', 'true');
		}
		if (!testFinished) {
			objSD.visits++;
			resumeTimerLC();
		}
		sendSessionDataAndProps();
		break;
	case "loadtestprops":
		if ((objQplayer != undefined) && (objSD.testProps != undefined)) {
			objQplayer.intervalCount = -1;
			if (objQplayer.intervalCount == -1) {
				//если настройки безопасности не запрещают доступ к объекту
				setVar(objQplayer, '_root.testProps', objSD.testProps);
			}
		}
		break;
	case "savetestpropsandcommit":
		if(testFinished){
			return;
		}
	case "savetestprops":
		if (testProps != undefined) {
			delete testProps;
		}
		testProps = new String(args);
		var i, params = testProps.slice(1, (i = testProps.indexOf("]") + 1) - 1);
		testProps = testProps.slice(i);
		var paramsArray = new Array();
		paramsArray = params.split(",");
		completionStatus = paramsArray[0];
		score = Number(paramsArray[1]);
		delete paramsArray;
		if(sCommand == "savetestpropsandcommit"){
			objSD.testProps = String(testProps);
			if (objSD.status != "completed") {
				objSD.attempts++;
			}
			if(oneAttempt){
				if(objSD.attempts >= 1){
					objSD.attempts = 1;
				}
			}
			objSD.score = (((completionStatus == "completed") || !noPartial) ? (((score*1.0)/100).toFixed(7)) : (0));
			objSD.status = (((completionStatus == "completed") || !noPartial) ? (completionStatus) : ("incomplete"));
			sendSessionDataAndProps();
			//
			if(autoNext){
				nextQuestionLC();
			}
		}
		break;
	default:;
	}
}
//
function fOnUnload(){
	if(commitObj != null){
		commitObj.closeConnection();
	}
}
//
function fOnLoad(){
	commitFlag = (commitObj == null);
	if(!commitFlag){
		try{
			objQplayer = document.getElementById(idQplayer);
		}catch(err){
			objQplayer = null;
		}
		//
		if(window.onresize != null){
			window.onresize = null;
		}else if(document.body.onresize != null){
			document.body.onresize = null;
		}
		//
		if (objQplayer != null) {
			if(objQplayer["attachEvent"]){
				objQplayer.detachEvent("onkeydown", my_onkeydown_handler);
				objQplayer.attachEvent("onkeydown", my_onkeydown_handler);
			}else if(objQplayer["addEventListener"]){
				objQplayer.removeEventListener("onkeydown", my_onkeydown_handler, false);
				objQplayer.addEventListener("onkeydown", my_onkeydown_handler, false);
			}
			//intervals – массив для хранения интервалов для разных переменных
			if(objQplayer.intervals == null){
				objQplayer.intervals = [];
			}
			while(objQplayer.intervals.length>0){
				clearInterval(objQplayer.intervals.shift().id);
			}
			//
			//НЕ УБИРАТЬ
			//var ii = window.setInterval("setVar(objQplayer, '_root.noResponse', 'true');", 50);
			//objQplayer.intervals.push({v:"_root.noResponse", id:ii, count:0});
			//
			_DoFSCommandPrev = window[objQplayer.id + "_DoFSCommand"];
			window[objQplayer.id + "_DoFSCommand"] = _DoFSCommandLC;
			//
		}
		//
		commitObj.fOnLoad(commitURL, true,
				{location:String(document.location), flagQplayer:(objQplayer!=null)});
	
		return;
	}
	//
	try{
		window.parent.notifyOnLoad();
	}catch(e){
		setDataValue = function(arg1,arg2){};
		commitData = function(){};
		terminate = function(){};
		swfobject.embedSWF(commit_swf_url, commitId, 1, 1, "9.0.0", expressInstall_swf_url, 
					{}, 
					{flashvars:"parent=false&documentURL="+commitURL}, 
					{id:commitId+"_swf"});
	}
}
